#include <iostream>
using namespace std;
int main()
{
    int n1;cin>>n1;
    int n[n1];
    for(int i=0;i<n1-1;i++){
        int x,y;
        cin>>x>>y;
    }
    for(int i=0;i<n1;i++){
        cin>>n[n1];
    }
    int m=0;
    for(int i=0;i<n1;i++){
        if(n[i]>=m)
            m=i+1;
    }
    int q1;
    cin>>q1;
    for(int i=0;i<q1;i++){
        int a,b;
        cin>>a>>b;
    }
    cout<<m<<endl;
    for(int i=0;i<q1;i++){
        if(2*i<n1-1){
            cout<<2*i<<endl;
        }
        else{
            cout<<i/2<<endl;
        }
    }
}